Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/OldSimpleTokenizerXml.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/OldSimpleTokenizerXml.groovy	(revision 3060)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/OldSimpleTokenizerXml.groovy	(revision 3061)
@@ -72,71 +72,71 @@
 import org.txm.tokenizer.TokenizerClasses;
 
 public class OldSimpleTokenizerXml {
-
+	
 	/** The word_tags. */
-	String word_tags = TokenizerClasses.word_tags;
-
+	String word_tags;
+	
 	/** The intraword_tags. */
-	String intraword_tags = TokenizerClasses.intraword_tags;
-
+	String intraword_tags;
+	
 	/** The punct_strong. */
-	def punct_strong = TokenizerClasses.punct_strong;
-
+	def punct_strong;
+	
 	/** The punct_all. */
-	def punct_all = TokenizerClasses.punct_all;
-
+	def punct_all;
+	
 	/** The word_chars. */
-	def word_chars = TokenizerClasses.word_chars;
-
+	def word_chars;
+	
 	def fclitics = null; // default behavior don't manage clitics
 	def pclitics = null; // default behavior don't manage clitics
-
+	
 	/** The ignorable_tags. */
 	String ignorable_tags
 	String outside_text_tags_keep_content
 	String outside_text_tags
 	String startTag = null
-
+	
 	/** The DEBUG. */
 	public boolean DEBUG = false;
-
+	
 	/** The outfile. */
 	File outfile;
-
+	
 	/** The infile. */
 	File infile;
-
+	
 	String lang;
-
+	
 	/** The buffer. */
 	StringBuffer buffer;
-
+	
 	/** The writer. */
 	XMLStreamWriter writer;
 	BufferedOutputStream output;
-
+	
 	/** The parser. */
 	XMLStreamReader parser
-
+	
 	/** The localname. */
 	String localname;
-
+	
 	/** The prefix. */
 	String prefix;
 	String filename;
-
+	
 	def regElision;
 	def reg3pts;
 	def regPunct;
 	def regFClitics = null ;
 	def regPClitics = null ;
 	String whitespaces;
-
+	
 	public OldSimpleTokenizerXml(File infile, File outfile)
 	{
 		this(infile, outfile, "");
 	}
-
+	
 	/**
 	 * Instantiates a new simple tokenizer xml.
 	 *
@@ -146,24 +146,40 @@
 	public OldSimpleTokenizerXml(File infile, File outfile, String lang)
 	{
 		this.lang = lang;
+		TokenizerClasses tc = new TokenizerClasses(lang)
 		if (lang != null)
 			if (lang.startsWith("en")) {
-				fclitics = TokenizerClasses.FClitic_en
+				fclitics = tc.FClitic_en
 			} else if (lang.startsWith("fr")) {
-				fclitics = TokenizerClasses.FClitic_fr
-				pclitics = TokenizerClasses.PClitic_fr
+				fclitics = tc.FClitic_fr
+				pclitics = tc.PClitic_fr
 			} else if (lang.startsWith("gl")) {
-				fclitics = TokenizerClasses.FClitic_gl
+				fclitics = tc.FClitic_gl
 			} else if (lang.startsWith("it")) {
-				pclitics = TokenizerClasses.PClitic_it
+				pclitics = tc.PClitic_it
 			}
-
+		
+		/** The word_tags. */
+		word_tags = tc.word_tags;
+		
+		/** The intraword_tags. */
+		intraword_tags = tc.intraword_tags;
+		
+		/** The punct_strong. */
+		punct_strong = tc.punct_strong;
+		
+		/** The punct_all. */
+		punct_all = tc.punct_all;
+		
+		/** The word_chars. */
+		word_chars = tc.word_chars;
+		
 		this.outfile = outfile;
 		this.infile = infile;
 		this.filename = infile.getName();
 		int index = filename.lastIndexOf(".");
 		if (index > 0) filename = filename.substring(0, index);
-
+		
 		String strRegElision = TokenizerClasses.regElision;
 		String strRegPunct = TokenizerClasses.regPunct;
 		regElision = /\A(.*?)(\p{L}++$strRegElision)(.*)\Z/
@@ -175,7 +191,7 @@
 			regPClitics = /(.+)(pclitics)(.*)/
 		whitespaces = TokenizerClasses.whitespaces;
 	}
-
+	
 	/**
 	 * Fill infos.
 	 *
@@ -190,7 +206,7 @@
 			prefix = parser.getPrefix();
 		}
 	}
-
+	
 	/**
 	 * Donothing.
 	 *
@@ -202,7 +218,7 @@
 	{
 		if (event == XMLStreamConstants.START_ELEMENT ) {
 			String namespace = parser.getNamespaceURI();
-
+			
 			localname = parser.getLocalName();
 			if (prefix != null && prefix.length() > 0)
 				writer.writeStartElement(prefix+":"+localname);
@@ -211,12 +227,12 @@
 				//					writer.writeStartElement(namespace, localname);
 				//				else
 				writer.writeStartElement(localname);
-
+			
 			//			if(parser.getNamespaceCount() > 0)
 			//				writer.writeDefaultNamespace(parser.getNamespaceURI(0))
 			//			for(int i = 1 ; i < parser.getNamespaceCount() ; i++)
 			//				writer.writeNamespace(parser.getNamespacePrefix(i), parser.getNamespaceURI(i));
-
+			
 			String namespace_prefix;
 			for (int i = 0 ; i<   parser.getNamespaceCount() ; i++) {
 				namespace_prefix = parser.getNamespacePrefix(i);
@@ -226,7 +242,7 @@
 					writer.writeDefaultNamespace(parser.getNamespaceURI(i));
 				}
 			}
-
+			
 			String attrprefix, attname;
 			boolean hasId = false;
 			boolean hasType = false
@@ -237,22 +253,22 @@
 				if ("id".equals(attname)) hasId = true;
 				if ("type".equals(attname)) hasType = true;
 				if ("n".equals(attname)) hasN = true;
-
+				
 				if(attrprefix != null && attrprefix.length() > 0)
 					writer.writeAttribute(attrprefix+":"+attname, parser.getAttributeValue(i))
 				else
 					writer.writeAttribute(attname, parser.getAttributeValue(i))
 			}
-
+			
 			if (wordid != null && !hasId && localname == "w")
 				writer.writeAttribute("id", "w_"+filename+"_"+wordcount);
-
+			
 			if (!hasType && localname == "w")
 				writer.writeAttribute("type", "w");
-
+			
 			if (!hasN && localname == "w")
 				writer.writeAttribute("n", ""+wordcount);
-
+			
 			writer.writeCharacters("\n");
 		}
 		else if(event == XMLStreamConstants.END_ELEMENT)
@@ -269,10 +285,10 @@
 			}
 		}
 	}
-
+	
 	/** The wordcount. */
 	int wordcount = 0;
-
+	
 	/** The ignorecontent. */
 	boolean ignorecontent = true;//tokenize a partir de <body>
 	boolean insideword = false;
@@ -291,7 +307,7 @@
 		output = new BufferedOutputStream(new FileOutputStream(outfile))
 		writer = factory.createXMLStreamWriter(output, "UTF-8")
 		writer.setNamespaceContext(new PersonalNamespaceContext());
-
+		
 		def inputData = infile.toURI().toURL().openStream();
 		def inputfactory = XMLInputFactory.newInstance();
 		//inputfactory.setProperty("http://apache.org/xml/properties/input-buffer-size", new Integer(2048));
@@ -300,7 +316,7 @@
 		//println "PARSER: "+parser.getClass()
 		writer.writeStartDocument("UTF-8","1.0");
 		writer.writeCharacters("\n");
-
+		
 		int previousEvent = 0;
 		boolean startProcess = false;
 		if (startTag == null) // if no startTag specified we process from the start
@@ -313,7 +329,7 @@
 				if (!startProcess) {
 					if (event == XMLStreamConstants.START_ELEMENT) {
 						if (parser.getLocalName().matches(startTag)) {
-
+							
 							startProcess = true
 							ignorecontent = false;
 						}
@@ -323,7 +339,7 @@
 						continue;
 					}
 				}
-
+				
 				if (previousEvent == XMLStreamConstants.CHARACTERS && previousEvent != event) {
 					processWord(); // tokenize
 					buffer = new StringBuffer();
@@ -331,7 +347,7 @@
 				fillInfos(event);//get localname and prefix
 				if (event == XMLStreamConstants.START_ELEMENT) {
 					//println "Open: "+localname;
-
+					
 					if (localname.matches(word_tags)) // ignore the content of the word but keep counting
 					{
 						//println "Found pretagged word";
@@ -385,7 +401,7 @@
 				}
 				previousEvent = event;
 			}
-
+			
 			parser.close()
 			writer.close();
 			output.close();
@@ -397,15 +413,15 @@
 		}
 		return true;
 	}
-
+	
 	public void setOutSideElements(String regexp) {
 		this.outside_text_tags = regexp;
 	}
-
+	
 	public void setOutSideTextTags(String regexp) {
 		this.outside_text_tags_keep_content = regexp;
 	}
-
+	
 	protected void goToEndOfElement(String name) {
 		//println "START ignoring tag and content of $name"
 		def openedTags = []
@@ -423,7 +439,7 @@
 			}
 		}
 	}
-
+	
 	/**
 	 * Process word.
 	 */
@@ -439,7 +455,7 @@
 			iterate(s);
 		}
 	}
-
+	
 	/**
 	 * Iterate. a String, should be called when a word is found in a String
 	 *
@@ -453,8 +469,8 @@
 			s = standardChecks(s);
 		}
 	}
-
-
+	
+	
 	/**
 	 * Standard checks.
 	 *
@@ -467,7 +483,7 @@
 		if (fclitics != null && (m = s =~ regFClitics) ) {
 			if (DEBUG) println "CLITIC found: $s ->"+ m[0][1]+" + "+m[0][2]+" + "+m[0][3]
 			if (m[0][1] != null && m[0][1].length() > 0) iterate(m[0][1]);// process first part of the string
-
+			
 			wordcount++;
 			writer.writeStartElement("w");
 			writeWordAttributes();// id
@@ -475,18 +491,18 @@
 			writer.writeCharacters(m[0][2]);
 			writer.writeEndElement();
 			writer.writeCharacters("\n");
-
+			
 			return m[0][3];
 		} else if ((m = s =~ regElision)) {
 			if (DEBUG) println "Elision found: $s ->"+ m[0][1]+" + "+m[0][2]+" + "+m[0][3]
 			iterate(m[0][1])
-
+			
 			int sep = s.indexOf("'");
 			if (sep < 0)
 				sep = s.indexOf("’");
 			if (sep < 0)
 				sep = s.indexOf("‘");
-
+			
 			wordcount++;
 			writer.writeStartElement("w");
 			writeWordAttributes();// id
@@ -494,14 +510,14 @@
 			writer.writeCharacters(m[0][2]);
 			writer.writeEndElement();
 			writer.writeCharacters("\n");
-
+			
 			return m[0][3];
 		}
 		else if ((m = s =~ reg3pts) )
 		{
 			if(DEBUG){println "REG '...' found: $s -> "+m[0][1]+" + "+m[0][2]+" + "+m[0][3]}
 			iterate(m[0][1])
-
+			
 			wordcount++;
 			writer.writeStartElement("w");
 			writeWordAttributes();// id
@@ -509,7 +525,7 @@
 			writer.writeCharacters("...");
 			writer.writeEndElement();
 			writer.writeCharacters("\n");
-
+			
 			return m[0][3];
 		}
 		else if ((m = s =~ regPunct) )
@@ -517,7 +533,7 @@
 		{
 			if(DEBUG){println "PUNCT found: $s ->"+m[0][1]+" + "+m[0][2]+" + "+m[0][3]}
 			iterate(m[0][1]);
-
+			
 			wordcount++;
 			writer.writeStartElement("w");
 			writeWordAttributes();// id
@@ -525,7 +541,7 @@
 			writer.writeCharacters(m[0][2]);
 			writer.writeEndElement();
 			writer.writeCharacters("\n");
-
+			
 			return m[0][3];
 		}
 		else
@@ -541,11 +557,11 @@
 			writer.writeCharacters(s);
 			writer.writeEndElement();
 			writer.writeCharacters("\n");
-
+			
 			return "";
 		}
 	}
-
+	
 	/**
 	 * Write word attributes.
 	 *
@@ -556,12 +572,12 @@
 		writer.writeAttribute("id", "w_"+filename+"_"+wordcount);
 		writer.writeAttribute("n",""+wordcount);
 	}
-
+	
 	public void setStartTag(String tag)
 	{
 		this.startTag = tag;
 	}
-
+	
 	/**
 	 * Tokenize.
 	 *
@@ -572,7 +588,7 @@
 	{
 		return str.tokenize()	// cut by whitespace
 	}
-
+	
 	/**
 	 * The main method.
 	 *
@@ -585,15 +601,15 @@
 		for (String lang : ["fr", null]) {
 			print "."
 			File outputFile = new File(inputDir, "test-${lang}.xml")
-
+			
 			OldSimpleTokenizerXml tokenizer = new OldSimpleTokenizerXml(inputFile, outputFile, lang)
 			tokenizer.DEBUG = true
 			tokenizer.process();
 		}
-
+		
 		println ""
 		println "Done"
-
+		
 		//		String lang = "en"
 		//		File inDir = new File("/home/mdecorde/xml/ny911/cycle1/Data_Modif_Pour_Import_XML_Cycle1/xml_files/1xml_par_participant")
 		//		File outDir = new File("/home/mdecorde/xml/ny911/cycle1/Data_Modif_Pour_Import_XML_Cycle1/xml_files/1xml_par_participant-t")
@@ -612,6 +628,6 @@
 		//		}
 		//		println ""
 		//		println "Done"
-
+		
 	}
 }
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/SimpleTokenizerXml.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/SimpleTokenizerXml.groovy	(revision 3060)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/SimpleTokenizerXml.groovy	(revision 3061)
@@ -64,14 +64,13 @@
 	LinkedHashMap<String, String>retokenizedWordProperties = new LinkedHashMap()
 	
 	/** The word_tags. */
-	String word_tags = TokenizerClasses.word_tags;
-	String word_element_to_create = TokenizerClasses.word_element_to_create;
+	String word_tags;
+	String word_element_to_create
 	Pattern reg_word_tags;
 	/** The intraword_tags. */
-	String intraword_tags = TokenizerClasses.intraword_tags;
-	
+	String intraword_tags
 	/** The word_chars. */
-	String word_chars = TokenizerClasses.word_chars;
+	String word_chars
 	
 	/** The outside_text_tags_ignore_content. */
 	String note_content = null;
@@ -118,21 +117,26 @@
 		this(infile, outfile, "");
 	}
 	
+	public SimpleTokenizerXml(File infile, File outfile, String lang) {
+		this(infile, outfile, new TokenizerClasses(lang));
+	}
+	
 	/**
 	 * Instantiates a new simple tokenizer xml.
 	 *
 	 * @param infile the infile
 	 * @param outfile the outfile
 	 */
-	public SimpleTokenizerXml(File infile, File outfile, String lang) {
-		this.lang = lang;
+	public SimpleTokenizerXml(File infile, File outfile, TokenizerClasses tc) {
+		this.lang = tc.lang;
 		this.stringTokenizer = new SimpleStringTokenizer(lang);
 		
-		word_tags = TokenizerClasses.word_tags;
+		word_tags = tc.word_tags;
+		word_element_to_create = tc.word_element_to_create;
 		reg_word_tags = Pattern.compile(word_tags);
 		
-		intraword_tags = TokenizerClasses.intraword_tags;
-		word_chars = TokenizerClasses.word_chars;
+		intraword_tags = tc.intraword_tags;
+		word_chars = tc.word_chars;
 		
 		this.outfile = outfile;
 		this.infile = infile;
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/TokenizerXml.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/TokenizerXml.groovy	(revision 3060)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/TokenizerXml.groovy	(revision 3061)
@@ -73,22 +73,9 @@
  * The Class TokenizerXml.
  */
 public class TokenizerXml {
-	
-	/** The word_tags. */
-	String word_tags = TokenizerClasses.word_tags;
-	
-	/** The intraword_tags. */
-	String intraword_tags = TokenizerClasses.intraword_tags;
-	
-	/** The punct_strong. */
-	def punct_strong = TokenizerClasses.punct_strong;
-	
-	/** The punct_all. */
-	def punct_all = TokenizerClasses.punct_all;
-	
-	/** The word_chars. */
-	def word_chars = TokenizerClasses.word_chars;
-	
+	
+	TokenizerClasses tc = new TokenizerClasses();
+		
 	/** The ignorable_tags. */
 	String ignorable_tags = "note"
 	
@@ -120,7 +107,7 @@
 	public TokenizerXml(File infile, File outfile)
 	{
 		this.outfile = outfile;
-		this.infile = infile;
+		this.infile = infile;
 	}
 	
 	/**
@@ -131,8 +118,7 @@
 	 */
 	public fillInfos(int event)
 	{
-		if (event == XMLStreamConstants.START_ELEMENT || event == XMLStreamConstants.END_ELEMENT) 
-		{
+		if (event == XMLStreamConstants.START_ELEMENT || event == XMLStreamConstants.END_ELEMENT) {
 			localname = parser.getLocalName();
 			prefix = parser.getPrefix();
 		}
@@ -147,27 +133,22 @@
 	public donothing(int event)
 	{
 		if (event == XMLStreamConstants.START_ELEMENT ) {
-			if(prefix != null && prefix.length() > 0)
+			if (prefix != null && prefix.length() > 0)
 				writer.writeStartElement(prefix+":"+localname);
 			else
 				writer.writeStartElement(localname);
 			String attrprefix;
-			for(int i = 0 ; i < parser.getAttributeCount() ; i++)
-			{
+			for (int i = 0 ; i < parser.getAttributeCount() ; i++) {
 				attrprefix = parser.getAttributePrefix(i);
 				if(attrprefix != null && attrprefix.length() > 0)
 					writer.writeAttribute(attrprefix+":"+parser.getAttributeLocalName(i), parser.getAttributeValue(i))
 				else
 					writer.writeAttribute(parser.getAttributeLocalName(i), parser.getAttributeValue(i))
 			}
-		}
-		else if(event == XMLStreamConstants.END_ELEMENT)
-		{
+		} else if(event == XMLStreamConstants.END_ELEMENT) {
 			writer.writeEndElement();
 			writer.writeCharacters("\n");
-		}
-		else if(event == XMLStreamConstants.CHARACTERS)
-		{
+		} else if(event == XMLStreamConstants.CHARACTERS) {
 			writer.writeCharacters(parser.getText());
 		}
 	}
@@ -188,19 +169,15 @@
 		def inputfactory = XMLInputFactory.newInstance();
 		parser = inputfactory.createXMLStreamReader(inputData);
 		
-		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) 
-		{
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
 			fillInfos(event);
-			if (event == XMLStreamConstants.START_ELEMENT) 
-			{
+			if (event == XMLStreamConstants.START_ELEMENT) {
 				//println "Open: "+localname;
-				if(localname == "text")
-				{
+				if (localname == "text") {
 					ignorecontent = false;
 					donothing(event);
 				}
-				if(localname.matches(word_tags))
-				{
+				if (localname.matches(tc.word_tags)) {
 					//println "Found pretagged word";
 					donothing(event);
 					wordcount++;
@@ -263,7 +240,7 @@
 							writer.writeCharacters(s);
 							writer.writeEndElement();
 							writer.writeCharacters("\n");
-						} else if(s.matches(/$punct_all|['‘’]/))
+						} else if(s.matches(/${tc.punct_all}|['‘’]/))
 										{
 							wordcount++;	
 							writer.writeStartElement("w");
@@ -308,7 +285,7 @@
 								writer.writeCharacters("\n");
 							}
 						}
-						else if(s.matches(/($punct_all)(.*)/))
+						else if(s.matches(/(${tc.punct_all})(.*)/))
 						{
 							wordcount++;	
 							writer.writeStartElement("w");
@@ -325,7 +302,7 @@
 							writer.writeEndElement();
 							writer.writeCharacters("\n");
 						}
-						else if(s.matches(/(.*)($punct_all)/))
+						else if(s.matches(/(.*)(${tc.punct_all})/))
 						{
 							wordcount++;	
 							writer.writeStartElement("w");
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/TEITokenizer.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/TEITokenizer.groovy	(revision 3060)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/scripts/filters/Tokeniser/TEITokenizer.groovy	(revision 3061)
@@ -4,7 +4,7 @@
 import java.util.regex.Pattern;
 
 import org.txm.importer.StaxIdentityParser;
-import org.txm.tokenizer.*;
+import org.txm.tokenizer.TokenizerClasses;
 
 public class TEITokenizer extends StaxIdentityParser {
 
@@ -14,7 +14,6 @@
 	STATES state = STATES.IGNORE;
 	String STARTTAG = ".*"
 	String NOTETAG = ""
-	//String WORDTAG = TokenizerClasses.word_tags;
 
 	static String PONTEST = "[.;:,!?]";
 	static String TYPE = "type";
@@ -22,19 +21,19 @@
 	static String PON = "pon"
 	static String NUM = "num"
 	static String ENDOFLINE = System.getProperty("line.separator");
-	def tests = TokenizerClasses.tests;
+	def tests;
 
 	int firstElement = 1;
 	String filename = "";
 	int wordcount = 0;
 	String previousElem;
 
-	def word_tags = TokenizerClasses.word_tags;
-	def intraword_tags = TokenizerClasses.intraword_tags;
-	def punct_strong = TokenizerClasses.punct_strong;
-	def punct_all = TokenizerClasses.punct_all;
-	def word_chars = TokenizerClasses.word_chars;
-	def punct_quotes = TokenizerClasses.punct_quotes;
+	def word_tags;
+	def intraword_tags;
+	def punct_strong;
+	def punct_all;
+	def word_chars;
+	def punct_quotes;
 
 	StringBuffer buffer = new StringBuffer();
 
@@ -43,8 +42,19 @@
 
 		this.filename = new File(inputurl.getFile()).getName();
 		int index = filename.lastIndexOf(".");
-		if (index > 0)
+		if (index > 0) {
 			filename = filename.substring(0, index);
+		}
+		
+		TokenizerClasses tc = new TokenizerClasses()
+		tests = tc.tests;
+			
+		word_tags = tc.word_tags;
+		intraword_tags = tc.intraword_tags;
+		punct_strong = tc.punct_strong;
+		punct_all = tc.punct_all;
+		word_chars = tc.word_chars;
+		punct_quotes = tc.punct_quotes;
 	}
 
 	protected void processBuffer() {
Index: tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SearchEditionToolbar.java
===================================================================
--- tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SearchEditionToolbar.java	(revision 3060)
+++ tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SearchEditionToolbar.java	(revision 3061)
@@ -3,26 +3,35 @@
 import java.util.List;
 
 import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.KeyEvent;
+import org.eclipse.swt.events.KeyListener;
 import org.eclipse.swt.events.SelectionEvent;
 import org.eclipse.swt.events.SelectionListener;
 import org.eclipse.swt.layout.GridData;
 import org.eclipse.swt.widgets.Button;
 import org.eclipse.swt.widgets.Composite;
+import org.txm.edition.rcp.handlers.BackToText;
 import org.txm.objects.Match;
 import org.txm.rcp.IImageKeys;
 import org.txm.rcp.swt.widget.AssistedChoiceQueryWidget;
 import org.txm.rcp.swt.widget.NewNavigationWidget;
 import org.txm.searchengine.core.IQuery;
 import org.txm.searchengine.core.Selection;
+import org.txm.searchengine.cqp.CQPSearchEngine;
 import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.searchengine.cqp.corpus.QueryResult;
 import org.txm.searchengine.cqp.corpus.query.CQLQuery;
+import org.txm.searchengine.cqp.corpus.query.MatchUtils;
 import org.txm.utils.logger.Log;
 
 public class SearchEditionToolbar {
 	
 	private GridData searchGdata;
 	
+	private GridData searchGdata2;
+	
+	private GridData searchGdata3;
+	
 	private AssistedChoiceQueryWidget searchText;
 	
 	/**
@@ -37,80 +46,85 @@
 	
 	private NewNavigationWidget searchNagigation;
 	
-	private GridData searchGdata2;
 	
+	
 	Composite lowerControlsArea;
 	
 	MainCorpus mcorpus;
 	
 	SynopticEditionEditor editor;
 	
+	private List<String> foundWordids;
+	
+	private Button searchButton;
+	
 	public void init(Composite lowerControlsArea, MainCorpus mcorpus, SynopticEditionEditor editor) {
 		
 		this.lowerControlsArea = lowerControlsArea;
 		this.mcorpus = mcorpus;
 		this.editor = editor;
 		
-		Button searchButton = new Button(lowerControlsArea, SWT.PUSH);
-		searchButton.setImage(IImageKeys.getImage(IImageKeys.ACTION_SEARCH));
-		searchButton.addSelectionListener(new SelectionListener() {
+		Button endSearchButton = new Button(lowerControlsArea, SWT.PUSH);
+		endSearchButton.setImage(IImageKeys.getImage(IImageKeys.ACTION_DELETE));
+		endSearchButton.addSelectionListener(new SelectionListener() {
 			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				if (searchGdata.widthHint == 0) {
-					searchGdata.minimumWidth = searchGdata.widthHint = 250;
-					searchGdata2.minimumWidth = searchGdata2.widthHint = 250;
+				if (searchGdata.widthHint > 0) {
+					searchGdata.minimumWidth = searchGdata.widthHint = 0;
+					searchGdata2.minimumWidth = searchGdata2.widthHint = 0;
+					searchGdata3.minimumWidth = searchGdata3.widthHint = 0;
 					lowerControlsArea.layout();
+					searchButton.setImage(IImageKeys.getImage(IImageKeys.ACTION_SEARCH));
 				}
-				else if (searchText.getQuery() != null) {
-					Log.info("Searching " + searchText.getQuery());
-					IQuery q = searchText.getQuery();
-					try {
-						Selection tmp = q.getSearchEngine().query(mcorpus, q, "SEARCH", false);
-						if (tmp.getNMatch() > 0) {
-							searchResult = tmp;
-							
-							searchIndex = 0;
-							String wordid = editor.getEditionPanel(0).getCurrentPage().getWordId();
-							String text = editor.getEditionPanel(0).getCurrentPage().getEdition().getText().getName();
-							if (wordid != null && text != null) {
-								QueryResult rez2 = mcorpus.query(new CQLQuery("[_.text_id=\"" + text + "\" & id=\"" + wordid + "\"]"), "SEARCHINIT", false);
-								if (rez2.getNMatch() > 0) {
-									int p = rez2.getMatch(0).getStart();
-									List<? extends Match> matches = searchResult.getMatches();
-									for (int i = 0; i < matches.size(); i++) {
-										if (p < matches.get(i).getStart()) {
-											searchIndex = i - 1; // previous index was the one
-											break;
-										}
-									}
-								}
-							}
-							searchNagigation.setEnabled(true);
-							searchNagigation.setCurrentPosition(searchIndex);
-							searchNagigation.setMinPosition(1);
-							searchNagigation.setMaxPosition(tmp.getNMatch());
-							searchNagigation.refresh();
-							Log.info("" + searchResult.getNMatch() + " matches.");
-						}
-					}
-					catch (Exception e1) {
-						// TODO Auto-generated catch block
-						e1.printStackTrace();
-					}
-				}
 			}
 			
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {}
 		});
+		searchGdata3 = new GridData(GridData.CENTER, GridData.CENTER, false, false);
+		searchGdata3.minimumWidth = 0;
+		searchGdata3.widthHint = 0;
+		endSearchButton.setLayoutData(searchGdata3);
 		
 		searchText = new AssistedChoiceQueryWidget(lowerControlsArea, SWT.NONE, mcorpus);
-		searchGdata = new GridData(GridData.CENTER, GridData.FILL, false, false);
+		searchGdata = new GridData(GridData.CENTER, GridData.CENTER, false, false);
 		searchGdata.minimumWidth = 0;
 		searchGdata.widthHint = 0;
 		searchText.setLayoutData(searchGdata);
+		searchText.addKeyListener(new KeyListener() {
+			
+			@Override
+			public void keyReleased(KeyEvent e) {
+				if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
+					if (searchText.getQuery() != null) {
+						search();
+					}
+				}
+			}
+			
+			@Override
+			public void keyPressed(KeyEvent e) {}
+		});
 		
+		searchButton = new Button(lowerControlsArea, SWT.PUSH);
+		searchButton.setImage(IImageKeys.getImage(IImageKeys.ACTION_SEARCH));
+		searchButton.addSelectionListener(new SelectionListener() {
+			
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				if (searchGdata.widthHint == 0) {
+					openSearch(editor.getTextSelection());
+				}
+				else if (searchText.getQuery() != null) {
+					search();
+				}
+			}
+			
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {}
+		});
+		
 		searchNagigation = new NewNavigationWidget(lowerControlsArea, SWT.NONE) {
 			
 			@Override
@@ -121,18 +135,103 @@
 				// Log.info("showing the " + index + " match.");
 			}
 		};
-		searchGdata2 = new GridData(GridData.CENTER, GridData.FILL, false, false);
+		searchGdata2 = new GridData(GridData.CENTER, GridData.CENTER, false, false);
 		searchGdata2.minimumWidth = 0;
 		searchGdata2.widthHint = 0;
 		searchNagigation.setLayoutData(searchGdata2);
 		searchNagigation.setEnabled(false);
+		
 	}
 	
+	/**
+	 * Open the search tool if not done
+	 */
+	public void openSearch(String value) {
+		if (searchGdata.widthHint == 0) {
+			searchGdata.minimumWidth = searchGdata.widthHint = 350; //
+			searchGdata2.minimumWidth = searchGdata2.widthHint = SWT.DEFAULT; // several buttons
+			searchGdata3.minimumWidth = searchGdata3.widthHint = SWT.DEFAULT; // button
+			lowerControlsArea.layout();
+			searchButton.setImage(IImageKeys.getImage(IImageKeys.START));
+		}
+		searchText.setFocus();
+		if (value != null && value.length() > 0) {
+			searchText.setText(value);
+		}
+	}
+	
+	protected void search() {
+		Log.info("Searching " + searchText.getQuery());
+		IQuery q = searchText.getQuery();
+		try {
+			Selection tmp = searchText.getQuery().getSearchEngine().query(mcorpus, q, "SEARCH", false);
+			if (tmp.getNMatch() > 0) {
+				searchResult = tmp;
+				
+				searchText.getQueryWidget().memorize();
+				
+				searchIndex = 0;
+				String wordid = editor.getEditionPanel(0).getCurrentPage().getWordId();
+				String text = editor.getEditionPanel(0).getCurrentPage().getEdition().getText().getName();
+				if (wordid != null && text != null) {
+					QueryResult rez2 = mcorpus.query(new CQLQuery("[_.text_id=\"" + text + "\" & id=\"" + wordid + "\"]"), "SEARCHINIT", false);
+					if (rez2.getNMatch() > 0) {
+						int p = rez2.getMatch(0).getStart();
+						List<? extends Match> matches = searchResult.getMatches();
+						for (int i = 0; i < matches.size(); i++) {
+							if (p < matches.get(i).getStart()) {
+								searchIndex = i; // previous index was the one
+								break;
+							}
+						}
+					}
+				}
+				searchNagigation.setEnabled(true);
+				searchNagigation.setCurrentPosition(searchIndex);
+				searchNagigation.setMinPosition(1);
+				searchNagigation.setMaxPosition(tmp.getNMatch());
+				searchNagigation.refresh();
+				Log.info("" + searchResult.getNMatch() + " hits.");
+			}
+			else {
+				searchIndex = 0;
+				searchNagigation.setEnabled(false);
+				searchNagigation.setCurrentPosition(0);
+				searchNagigation.setMinPosition(0);
+				searchNagigation.setMaxPosition(0);
+				searchNagigation.refresh();
+				Log.info("No hit.");
+			}
+		}
+		catch (Exception e1) {
+			// TODO Auto-generated catch block
+			e1.printStackTrace();
+		}
+	}
+	
 	protected void showCurrentSearchMatch() {
 		if (searchResult != null && searchIndex >= 0) {
-			String text = "";
-			String wordid = "";
-			editor.getEditionPanel(0).backToText(editor.getResult().getProject().getText(text), wordid);
+			try {
+				if (foundWordids != null) {
+					editor.removeHighlightWordsById(BackToText.red, foundWordids);
+					editor.setFocusedWordID(null);
+					editor.updateWordStyles();
+				}
+				Match match = searchResult.getMatches().get(searchIndex);
+				String text = CQPSearchEngine.getEngine().getValueForProperty(match, mcorpus.getStructuralUnitProperty("text_id"));
+				int[] positions = MatchUtils.toPositions(match);
+				foundWordids = CQPSearchEngine.getEngine().getValuesForProperty(positions, mcorpus.getProperty("id"));
+				if (foundWordids.size() == 0) return;
+				
+				editor.getEditionPanel(0).backToText(editor.getResult().getProject().getText(text), foundWordids.get(0));
+				editor.addHighlightWordsById(BackToText.red, foundWordids);
+				editor.setFocusedWordID(foundWordids.get(0));
+				editor.updateWordStyles();
+			}
+			catch (Exception e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
 		}
 	}
 }
Index: tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java
===================================================================
--- tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java	(revision 3060)
+++ tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java	(revision 3061)
@@ -21,6 +21,8 @@
 import org.eclipse.swt.browser.Browser;
 import org.eclipse.swt.browser.ProgressEvent;
 import org.eclipse.swt.browser.ProgressListener;
+import org.eclipse.swt.events.KeyEvent;
+import org.eclipse.swt.events.KeyListener;
 import org.eclipse.swt.events.MenuEvent;
 import org.eclipse.swt.events.MenuListener;
 import org.eclipse.swt.events.MouseEvent;
@@ -604,6 +606,20 @@
 			}
 		});
 		
+		getBrowser().addKeyListener(new KeyListener() {
+			
+			@Override
+			public void keyReleased(KeyEvent e) {
+				
+				if (e.keyCode == 102 && (e.stateMask & SWT.CTRL) != 0) {
+					synopticEditionEditor.getSearchEditionToolbar().openSearch(getTextSelection());
+				}
+			}
+			
+			@Override
+			public void keyPressed(KeyEvent e) {}
+		});
+		
 		getBrowser().addProgressListener(progresslistener);
 		new CommandLink(synopticEditionEditor, getBrowser());
 		new EditionLink(synopticEditionEditor, getBrowser());
